-- phpMyAdmin SQL Dump
-- version 2.10.3deb1ubuntu0.2
-- http://www.phpmyadmin.net
--
-- Serveur: localhost
-- Généré le : Ven 04 Juillet 2008 à 11:57
-- Version du serveur: 5.0.45
-- Version de PHP: 5.2.3-1ubuntu6.3

-- Création de la base Mysql pour scribe-posh
-- Equipe Eole 2008

-- création de la base de donnée
CREATE DATABASE poshprofile;

-- création du user de la base
grant all privileges on poshprofile.* to posh@localhost identified by 'posh';
flush privileges ;

-- connexion à la base
\r poshprofile



SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";

--
-- Base de données: `poshprofile`
--

-- --------------------------------------------------------

--
-- Structure de la table `desktopitem`
--

CREATE TABLE IF NOT EXISTS `desktopitem` (
  `desktopid` mediumint(9) NOT NULL auto_increment COMMENT 'id de l item de bureau dans la base',
  `name` varchar(32) character set utf8 collate utf8_bin NOT NULL COMMENT 'nom du bouton',
  `libelle` varchar(32) character set utf8 collate utf8_bin NOT NULL COMMENT 'libellé du bouton',
  `url` varchar(150) character set utf8 collate utf8_bin NOT NULL COMMENT 'url de l application associée au bouton',
  `icon` varchar(150) character set utf8 collate utf8_bin NOT NULL COMMENT 'icone du bouton',
  PRIMARY KEY  (`desktopid`),
  UNIQUE KEY `url` (`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci COMMENT='item de bureau posh' AUTO_INCREMENT=5 ;

--
-- Contenu de la table `desktopitem`
--

INSERT INTO `desktopitem` (`desktopid`, `name`, `libelle`, `url`, `icon`) VALUES
(1, 'mail', 'Mes<br />e-mails', '/mail', '/posh/includes/plugins/plugin_desktop/icones/mail.png'),
(2, 'ftp', 'Mes<br />dossiers', '/%%posh_ftp_plugin/', '/posh/includes/plugins/plugin_desktop/icones/dir.png'),
(3, 'gepi', 'Suivi scolaire', '/gepi', ''),
(4, 'gibii', 'B2i', '/gibii', '');


-- --------------------------------------------------------

--
-- Structure de la table `profile`
--

CREATE TABLE IF NOT EXISTS `profile` (
  `profileid` mediumint(9) NOT NULL auto_increment COMMENT 'id du profil dans la base',
  `name` varchar(32) character set utf8 collate utf8_bin NOT NULL COMMENT 'nom du profil',
  `description` varchar(32) character set utf8 collate utf8_bin NOT NULL COMMENT 'description du profil',
  PRIMARY KEY  (`profileid`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci COMMENT='profil posh' AUTO_INCREMENT=5 ;

--
-- Contenu de la table `profile`
--

INSERT INTO `profile` (`profileid`, `name`, `description`) VALUES
(1, 'professeur', 'Professeur'),
(2, 'eleve', 'Elève'),
(3, 'administrateur', 'Administrateur'),
(4, 'main_user', 'Utilisateur par défaut');

-- --------------------------------------------------------

--
-- Structure de la table `profiledesktoplink`
--

CREATE TABLE IF NOT EXISTS `profiledesktopitem` (
  `profileid` mediumint(9) NOT NULL COMMENT 'identificateur du profil',
  `desktopid` mediumint(9) NOT NULL COMMENT 'identificateur de l item de bureau',
  KEY `FK_profiledesktoplink_profileid` (`profileid`),
  KEY `FK_profiledesktoplink_desktopid` (`desktopid`),
  UNIQUE KEY `uniq_profiledesktoplink` (`desktopid`, `profileid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci COMMENT='table de lien entre profile et item de bureau';

--
-- Contenu de la table `profiledesktoplink`
--

INSERT INTO `profiledesktopitem` (`profileid`, `desktopid`) VALUES
(1, 1),
(1, 2),
(2, 1),
(2, 2);

-- --------------------------------------------------------

--
-- Structure de la table `profilethumblink`
--

CREATE TABLE IF NOT EXISTS `profilethumb` (
  `profileid` mediumint(9) NOT NULL COMMENT 'identificateur du profil',
  `thumbid` mediumint(9) NOT NULL COMMENT 'identificateur de l onglet',
  KEY `FK_profilethumblink_profileid` (`profileid`),
  KEY `FK_profilethumblink_thumbid` (`thumbid`),
  UNIQUE KEY `uniq_profilethumblink` (`thumbid`, `profileid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci COMMENT='table de lien entre profile et onglet';

--
-- Contenu de la table `profilethumblink`
-- prof/eleve/admin

INSERT INTO `profilethumb` (`profileid`, `thumbid`) VALUES
(1, 3),
(1, 4),
(2, 3),
(3, 4),
(3, 5);

-- --------------------------------------------------------

--
-- Structure de la table `profileuserattrlink`
--

CREATE TABLE IF NOT EXISTS `userattrprofile` (
  `userattrid` mediumint(9) NOT NULL COMMENT 'identificateur de l attribut utilisateur',
  `profileid` mediumint(9) NOT NULL COMMENT 'identificateur du profil',
  KEY `FK_profileuserattrlink_userattrid` (`userattrid`),
  KEY `FK_profileuserattrlink_profileid` (`profileid`),
  UNIQUE KEY `uniq_userattrprofilelink` (`userattrid`, `profileid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci COMMENT='table de lien entre profile et attribut utilisateur';

--
-- Contenu de la table `profileuserattrlink`
--

INSERT INTO `userattrprofile` (`userattrid`, `profileid`) VALUES
(1, 1),
(2, 1),
(3, 4),
(5, 2),
(4, 3);

-- --------------------------------------------------------

--
-- Structure de la table `thumb`
--

CREATE TABLE IF NOT EXISTS `thumb` (
  `thumbid` mediumint(9) NOT NULL auto_increment COMMENT 'id de l onglet dans la base',
  `name` varchar(32) character set utf8 collate utf8_bin NOT NULL COMMENT 'nom de l onglet',
  `description` varchar(32) character set utf8 collate utf8_bin NOT NULL COMMENT 'description de l onglet',
  `indice` mediumint(9) NOT NULL default '2' COMMENT 'placement de l''onglet',
  `poshtype` smallint(6) NOT NULL COMMENT 'type de l''onglet',
  `url` varchar(150) character set utf8 collate utf8_bin NOT NULL COMMENT 'url de l application associée à  l onglet',
  `admin_profile_id` TINYINT( 3 ) NOT NULL default '-1',
  PRIMARY KEY  (`thumbid`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci COMMENT='onglet posh' AUTO_INCREMENT=6 ;

--
-- Contenu de la table `thumb`
--

INSERT INTO `thumb` (`thumbid`, `name`, `description`, `indice`, `poshtype`, `url`) VALUES
(1, 'mail', 'Mes e-mails', 4, 2, '/mail/'),
(2, 'ftp', 'Mes dossiers', 3, 2, '/%%posh_ftp_plugin'),
(3, 'desktop', 'Mon Bureau', 1, 2, '/posh/includes/plugins/plugin_desktop/desktop.php'),
%if %%adresse_ip_eth0 == %%posh_cas_ip
(4, 'ead2', 'Administration', 2, 2, 'https://%%posh_domainname:4200/'),
(5, 'admin-profil', 'Gestion des profils', 1, 2, 'http://%%posh_domainname:7070');
%else
(4, 'ead2', 'Administration', 2, 2, 'https://%%adresse_ip_eth0:4200/'),
(5, 'admin-profil', 'Gestion des profils', 1, 2, 'http://%%adresse_ip_eth0:7070');
%end if

-- --------------------------------------------------------

--
-- Structure de la table `userattr`
--

CREATE TABLE IF NOT EXISTS `userattr` (
  `userattrid` mediumint(9) NOT NULL auto_increment COMMENT 'id du profil dans la base',
  `attrname` varchar(32) character set utf8 collate utf8_bin NOT NULL COMMENT 'nom de l attribut utilisateur',
  `attrvalue` varchar(32) character set utf8 collate utf8_bin NOT NULL COMMENT 'valeur de l attribut',
  PRIMARY KEY  (`userattrid`),
  UNIQUE KEY `couple_userattr_attrvalue` (`attrname`, `attrvalue`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci COMMENT='profil posh' AUTO_INCREMENT=6 ;

--
-- Contenu de la table `userattr`
--

INSERT INTO `userattr` (`userattrid`, `attrname`, `attrvalue`) VALUES
(1, 'typeadmin', '0'),
(2, 'typeadmin', '2'),
(3, 'uid', 'None'),
(4, 'uid', 'admin'),
(5, 'user_groups', 'eleves');
