<?php
# *********************** LICENSE *****************************************************	#
#	This file is part of AutoCreat plugin.						#
#											#
#	AutoCreat plugin is free software; you can redistribute it and/or modify	#
#	it under the terms of the GNU General Public License as published by		#
#	the Free Software Foundation; either version 2 of the License, or		#
#	(at your option) any later version.						#
#											#
#	CAS plugin is distributed in the hope that it will be useful,			#
#	but WITHOUT ANY WARRANTY; without even the implied warranty of			#
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			#
#	GNU General Public License for more details.					#
#											#
#	You should have received a copy of the GNU General Public License		#
#	along with Foobar; if not, write to the Free Software				#
#	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA	#
# *************************************************************************************	#


/************************************************
*   AutoCreat plugin file	        	*
*   file: plugin_AC.php				*
*   version: 1.00                           	*
*   date: 07/11/07                          	*
*   author: Jean-francois Rey               	*
*   email: jean-francois.rey@univ-avignon.fr  	*
************************************************/

/*
 * name: AutoCreat plugin
 * description: Create automaticaly a posh account at the first login.
 * dependencies: no
 * author: Jean-François REY
 * url: http://gpl.univ-avignon.fr
 */

 define("AC_NAME","AutoCreat plugin");


/*
  * Registers the action in order to uninstall the plugin
  */
 register_hook('uninstall_plugin_AC/plugin_AC','plugac_uninstall');

// show configuration
 register_hook("display_plugin","plugac_display",10,1);
// save configuration in DB
 register_hook("admin_scr_config_plugins","plugac_save_config");
// create account if not
 register_hook("user_login_form","plugac_user_login_form",1,2);

 // show configuration
 function plugac_display($info)
 {
	if($info['name'] == AC_NAME )
	{
		if (__LANG=="fr"){ $GLOBALS['lgMap']['autocreate']="Creation du compte utilisateur automatique a la 1ere connexion :"; }
		else{ $GLOBALS['lgMap']['autocreate']="Automaticaly user account creation at the first login :"; }

		$autocreat = 'N';
		global $DB;
		$sql = "SELECT parameter,value FROM adm_config WHERE parameter='autoCreat';";
		$DB->getResults($sql);
		while ($row=$DB->fetch(0)){
			if ($row["parameter"]=="autoCreat") $autocreat=$row["value"];
		}
		$DB->freeResults();

		echo '<tr><td colspan="3">',
			"<input type='hidden' value='0' name='modifAC_plugin' />",
			"<table cellpadding='0' cellspacing='0' width='100%'>",
				"<tr>",
				"<td class='label'><img src='../images/ico_right_arrow.gif' /> ",
				lg("autocreate")."</td>",
				"<td>",
				"<input type='checkbox' name='autoCreat' value='Y'";
					if($autocreat == 'Y') echo " checked='checked'";
				echo "onChange='form.modifAC_plugin.value=1;'/>",
				"</td>",
				"</tr>",
			"</table>",
			"</td></tr>";

	}
 }

/*
  * Uninstall function
  */

function plugac_uninstall()
{
	global $DB;
	$sql = "DELETE FROM `adm_config` WHERE CONVERT(`adm_config`.`parameter` USING utf8)='autoCreat' LIMIT 1;";
	$DB->execute($sql);
	$DB->freeResults();
}


 /*
 * Save plugin configuration in Data Base
 */

 function plugac_save_config()
{
	$inc=0;
	while ( isset($_POST["plugi".$inc]) )
	{
		if($_POST["name".$inc] == AC_NAME)
		{
			if($_POST["modifAC_plugin"] == 1)
			{
				global $DB;
				$sql = 'UPDATE adm_config SET value="'.$_POST["autoCreat"].'" WHERE parameter="autoCreat" ';
				$DB->execute($sql);
				if ($DB->nbAffected()==0){
        				$sql = 'INSERT INTO adm_config (parameter,value,datatype,desttype) ';
        				$sql.= 'VALUES ("autoCreat","'.$_POST["autoCreat"].'","str","P") ';
        				$DB->execute($sql);
				}
			}
			break;
		}
		$inc++;
	}
}

function plugac_user_login_form($username,$password)
{
	global $DB,$authentif_getUserByName;

	$DB->getResults($authentif_getUserByName,$DB->quote($username));
	if ($DB->nbResults()<=0 && $username!=""){
		//add the new user
		$DB->execute("INSERT INTO users (username,pass,long_name,typ,lastconnect_date,md5pass,md5user) VALUES (%s,'',%s,%s,CURRENT_DATE,MD5(%s),%s) " ,$DB->quote($username),$DB->quote($username),$DB->quote("I"),$DB->quote($password),$DB->quote(md5($username.$password)));
		// new user_id
		$userid=$DB->getId();
		//add to log
		$DB->execute($scrsubscribe_log,$DB->escape($id));
		$DB->freeResults();

		//group management (for type I only)
		//Suppress the old group mapping
		/*$DB->execute("DELETE FROM users_group_map WHERE user_id=%u ", $DB->escape($userid));
		$i=0;
		while (isset($_POST["group".$i])){
			$DB->execute("INSERT INTO users_group_map (user_id,group_id) VALUES (%u,%u) ", $DB->escape($userid),$DB->escape($_POST["group".$i]));
			$i++;
		}*/
	}


}

?>
