<?php
# *********************** LICENSE *****************************************************	#
#	This file is part of EoleCAS plugin.
#
#	Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
#	Licence CeCill  cf /root/LicenceEole.txt
#	eole@ac-dijon.fr
# *************************************************************************************	#


/************************************************
*   EoleCAS plugin file		                   	*
*   Extension of CAS plugin file                *
*   from Jean-francois Rey                      *
*   jean-francois.rey@univ-avignon.fr           *
*   file: plugin_eolecas.php			        *
*   version: 2.00                           	*
*   date: 07/11/07                          	*
*   author : Gaston TJEBBES               	    *
*   email: g.tjebbes@ac-dijon.fr              	*
************************************************/

/*
 * name: plugin EOLECAS
 * description: EOLECAS plugin
 * dependencies: no
 * author: Gaston TJEBBES
 * url: http://eole.orion.education.fr
 */

define("CAS_NAME","plugin EOLECAS");

include_once("configCAS/cas.inc.php");
//include_once('CAS/CAS.php');
include_once('CAS/eoleCAS.php');

/*
  * Registers the action in order to install and uninstall the plugin
  */
 register_hook('install_plugin_eolecas/plugin_eolecas','plugcas_install');
 register_hook('uninstall_plugin_eolecas/plugin_eolecas','plugcas_uninstall');

// show configuration
 register_hook("display_plugin","plugcas_display",8,1);
// save configuration in DB
 register_hook("admin_scr_config_plugins","plugcas_save_config");
// save configuration in file
 register_hook("admin_scr_generate_configfiles","plugcas_save_file");
// how to login
 register_hook("userinterface_header","plugcas_userinterface_header",1,1);
// how to redirect after cas
 register_hook("userinterface_end","plugcas_userinterface_end",1,1);
// logout from cas server
 register_hook("logout","plugcas_logout");
// Admin logout
 register_hook("admin_header","plugcas_admin_header");
// login form
 register_hook("display_login_form","plugcas_display_login_form");

 // show configuration
 function plugcas_display($info)
 {
     if($info['name'] == CAS_NAME ){
         require_once("plugin_eolecas_config.php");
     }
 }

/*
  * Install function
  */
function plugcas_install()
{
	$inc=0;
	while ( isset($_POST["plugi".$inc]) )
	{
		if($_POST["name".$inc] == CAS_NAME && $_POST["plugi".$inc] == 0)
		{
			global $DB;
			// create table adm_config_ldap
			$sql = "DROP TABLE IF EXISTS `adm_config_cas`;";
			$DB->execute($sql);
			$sql = "CREATE TABLE `adm_config_cas` (`parameter` varchar(16) character set utf8 collate utf8_unicode_ci NOT NULL default '', `value` text character set utf8 collate utf8_unicode_ci NOT NULL, `datatype` char(3) NOT NULL default '', `desttype` char(1) NOT NULL default '', PRIMARY KEY  (`parameter`)) TYPE=MyISAM DEFAULT CHARSET=utf8 COMMENT='CAS plugin configuration parameters';";
			$DB->execute($sql);
			break;
		}
		$inc++;
	}
}

/*
  * Uninstall function
  */
function plugcas_uninstall()
{
	global $DB;
	$sql = "DROP TABLE IF EXISTS `adm_config_cas`;";
	$DB->execute($sql);
}

/*
 * Save plugin configuration in Data Base
 */
 function plugcas_save_config()
{
	$inc=0;
	while ( isset($_POST["plugi".$inc]) )
	{
		if($_POST["name".$inc] == CAS_NAME)
		{
			if($_POST["modifCas_plugin"] == 1)
			{
				require_once("scr_plugin_eolecas_config.php");
			}
			break;
		}
		$inc++;
	}
}

// save configuration in file cas.inc.php
 function plugcas_save_file()
{
global $DB;

// save on file
$contentcas="<?php".chr(13).chr(10);

// read config from DB
$sql = "SELECT parameter,value,datatype,desttype FROM adm_config_cas ";
$DB->getResults($sql);
while ($row = $DB->fetch(0)){
	if ($row["desttype"]=="C"){
                switch($row["datatype"]){
                        case "int":
                                $contentcas.='define("__'.$row["parameter"].'",'.$row["value"].');'.chr(13).chr(10);
                                break;
                        case "str":
                                $contentcas.='define("__'.$row["parameter"].'","'.addslashes($row["value"]).'");'.chr(13).chr(10);
                                break;
                        case "arr":
                                $contentcas.='$'.'__'.$row["parameter"].'='.$row["value"].';'.chr(13).chr(10);
                                break;
                }
        }
}
$DB->freeResults();

// create and/or create the file cas.inc.php
if (!$handle = fopen("../includes/plugins/plugin_eolecas/cas.inc.php", 'w+'))
{
	echo "Can\'t open cas.inc.php file";
        exit;
}

if (fwrite($handle, $contentcas."?>") === FALSE) {
	echo "Can't write in cas.inc.php file";
        exit;
}
fclose($handle);

}

// userinterface : first things are do! -> login
function plugcas_userinterface_header($page)
{
// log to cas server
if( __defaultAuthen=="cas" && $page=="portal/index.php" )
{
    echo "<script type='text/javascript'>";
	// first connected
	// go to cas if not already went to cas
	if(__defaultmode=="connected" && !isset($_REQUEST['ticket']) )
	{
	   echo "link('".__CAS_PROTO."://".__CAS_SERVER.__CAS_FOLDER.":".__CAS_PORT."/login?service=".__CAS_RETURN."/login.php');";
	}
	// default
	// login send to cas
	else
    {
		//login menu
		echo "function connectBox(){link('".__CAS_PROTO."://".__CAS_SERVER.__CAS_FOLDER.":".__CAS_PORT."/login?service=".__CAS_RETURN."/index.php');}";
		// Save menu!!
		echo 	"function showSave(){\n",
			"if (showBoxStatus){hideBox();}\n",
			"var l_s=\"<table><tr>\";\n",
			"l_s+=\"<td valign=top width='400'><div class='bottomhr'><b>\"+lg(\"lblAccountCreation\")+\" \"+__apname+\" :</b></div><br />\";\n",
			"l_s+=\"<form name='form1' method='post' onsubmit=\\\"return link('".__CAS_PROTO."://".__CAS_SERVER.__CAS_FOLDER.":".__CAS_PORT."/login?service=".__CAS_RETURN."/index.php?connect=firstsave');\\\">\";\n",
			"l_s+=\"<table cellspacing='0' cellpadding='0' border='0'>\"\n",
			"l_s+=\"<center><input class='btn' type='submit' name='\"+lg(\"lblOk\")+\"' style='width:250px' value='\"+lg(\"lblSavePage\")+\"' /></center>\"\n",
			"l_s+=\"</table></form><br />\";\n",

			"l_s+=\"</td><td width='50'></td><td valign='top' width='400'><div class='bottomhr'><b>\"+lg(\"lblAlreadyMember\")+\" ?</b></div>\";",
			"l_s+=\"<form name='form2' method='post' onsubmit=\\\" return link('".__CAS_PROTO."://".__CAS_SERVER.__CAS_FOLDER.":".__CAS_PORT."/login?service=".__CAS_RETURN."/index.php?connect=save');\\\">\";",
			"l_s+=\"<table cellspacing='0' cellpadding='0' border='0'>\";",
			"l_s+=\"<tr><td colspan='2' align='center'><br /><input class='btn' type='submit' value='\"+lg(\"lblSavePage\")+\"' style='width:250px' /></td></tr>\";",
			"l_s+=\"</table></form>\";",
			"l_s+=\"</td></tr></table>\";",
			"navPrint(\"box\",box(0,img(\"ico_menu_disk.gif\",16,16,\"\",\"imgmid\")+\" \"+lg(\"lblSavePage\"),\"hideBox()\",l_s));\n",
			"navShow(\"box\",\"block\");",
			"showBoxStatus=true;\n",
			"return false;",
			"}";
	}
   echo "p_network.changeProfile = new Function(\"link('".__LOCALFOLDER."portal/scr_authentif.php?act=logout&from=change');\");";
   echo "</script>";

}
elseif(__defaultAuthen == "cas" && $page == "portal/login.php" && !isset($_REQUEST['ticket']) ){
                echo "<script type='text/javascript'>";
                 echo "link('".__CAS_PROTO."://".__CAS_SERVER.__CAS_FOLDER.":".__CAS_PORT."/login?service=".__CAS_RETURN."/login.php');";
                 // my profile menu when change user
                 echo "p_network.changeProfile = new Function(\"link('".__LOCALFOLDER."portal/scr_authentif.php?act=logout&from=change');\");";
                 echo "</script>";
}
}

// login.php
function plugcas_display_login_form(){
    echo "<script type='text/javascript'>";
	eolephpCAS::proxy(__CAS_VERSION,__CAS_SERVER,__CAS_PORT,__CAS_FOLDER,false);

	if(__LANG=="fr") eolephpCAS::setLang(PHPCAS_LANG_FRENCH);
	else eolephpCAS::setLang(PHPCAS_LANG_ENGLISH);

	//eolephpCAS::forceAuthentication();
	if(eolephpCAS::checkAuthentication())
    {
		// ok go to user page
        $user = eolephpCAS::getUser();
		echo "var fcas = new Array(); fcas.password = new Array(); fcas.password.value=1;";
		echo "fcas.username = new Array(); fcas.username.value='".$user."';";
        echo "p_connection.set(fcas,p_pages.isPageExisting);";
	}
    else{
        echo "link('".__CAS_PROTO."://".__CAS_SERVER.__CAS_FOLDER.":".__CAS_PORT."/login?service=".__CAS_RETURN."/login.php');";
    }
    echo "</script>";
}

// page index end
function plugcas_userinterface_end($page)
{
// if went to cas server, got a ticket -> check it
if( __defaultAuthen=="cas" && $page=="portal/index.php" && isset($_REQUEST['ticket']))
{
    eolephpCAS::setDebug('/tmp/phpCAS.log');
	eolephpCAS::proxy(__CAS_VERSION,__CAS_SERVER,__CAS_PORT,__CAS_FOLDER,false);

	if(__LANG=="fr") eolephpCAS::setLang(PHPCAS_LANG_FRENCH);
	else eolephpCAS::setLang(PHPCAS_LANG_ENGLISH);

	//eolephpCAS::forceAuthentication();
	if(eolephpCAS::checkAuthentication())
	{
		// ok go to user page
		$user = eolephpCAS::getUser();
		echo "<script type='text/javascript'>";
		echo "var fcas = new Array(); fcas.password = new Array(); fcas.password.value=1;";
		echo "fcas.username = new Array(); fcas.username.value='".$user."';";

		// link save
		if(isset($_REQUEST['connect']))
		{
			//first connection
			if( $_REQUEST['connect'] == "firstsave")
			{
				echo "fcas.pass = new Array(); fcas.pass.value=1;fcas.confpass = new Array(); fcas.confpass.value=1;",
				"fcas.autoconn = new Array();";
				echo "p_connection.subscribe(fcas,savePage);";
			}
			// already connected
			else echo "p_connection.set(fcas,savePage);";
		}
		// login
		else
		{
			echo "window.stop();";
			echo "p_connection.set(fcas,link,true);";
		}
		echo "</script>";
	}
}
}

// check authentication cas
if ( __defaultAuthen=="cas" && !function_exists('user_login_form') ):
// call by user_login
function user_login_form($username,$password,&$user,&$errormsg)
{
	global $DB,$authentif_getUserByName;
	launch_hook('user_login_form',$username,$password);
	//Check the password
	$DB->getResults($authentif_getUserByName,$DB->quote($username));
	if ($DB->nbResults()<=0)
	{
		$errormsg.=lg("incorrectLogin");
	} else
	{
		$row=$DB->fetch(0);
		if ($row["typ"]=="N" OR $row["typ"]=="M")
		{
			$errormsg.=lg("userNotValidated");
		}
		else
		{
			if( $row["typ"]=="A" )
			{
				if( $row["password"]<>md5($password) )
				{
					$errormsg.=lg("incorrectLogin");
				}
			}
			else
			{
				eolephpCAS::proxy(__CAS_VERSION,__CAS_SERVER,__CAS_PORT,__CAS_FOLDER,false);

				if(__LANG=="fr") eolephpCAS::setLang(PHPCAS_LANG_FRENCH);
				else eolephpCAS::setLang(PHPCAS_LANG_ENGLISH);

				//eolephpCAS::forceAuthentication();
				if(eolephpCAS::checkAuthentication())
				{
					// ok go to user page
                    $username = eolephpCAS::getUser();
				}
				else
				{
					$errormsg.=lg("incorrectLogin");
				}
			}
		    }
		if( $errormsg == "" )
		{
			$user->id=$row["id"];
			$user->username=$username;
			$user->type=$row["typ"];
			$user->lang=$row["lang"];
			$user->longname=$row["long_name"]==""?$username:$row["long_name"];
			$user->pass = md5($password);
			$DB->freeResults();
			return true;
		}
	}
	$DB->freeResults();
	return false;
}
endif;

// logout
function plugcas_logout()
{
	if (__defaultAuthen=="cas"){
		if(isset($_GET["act"]) && $_GET["act"]=="logout" && $_GET["from"] != "A") { // not admin
	        	// initialize eolephpCAS
			eolephpCAS::proxy(__CAS_VERSION,__CAS_SERVER,__CAS_PORT,__CAS_FOLDER,false);
			if(__LANG=="fr") eolephpCAS::setLang(PHPCAS_LANG_FRENCH);
			else eolephpCAS::setLang(PHPCAS_LANG_ENGLISH);
			eolephpCAS::logout(__CAS_RETURN);
		}
	}
}

// admin logout
function plugcas_admin_header()
{
	echo "<script type='text/javascript'>\n",
	"function logout(){link('".__LOCALFOLDER."portal/scr_authentif.php?act=logout&from=A');}\n",
	"</script>\n";
}
?>
